--    Program: 		CAPAREXT_CUSTOMER_SITE_USE.sql
--    Description:	Extract AR Customer Site Use information 
--    Revision:		1st     
--    Parameter: 	1. set of books short name e.g. SOB_C999

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
                    		
   l_utl_file       		utl_file.file_type;
   l_filename       		varchar2(255);
   l_pathname       		varchar2(100);
                    		
   l_ngo_sob				varchar2(20);
   l_set_of_books_id		number;
   
   cursor cur_site_use (p_set_of_books_id number) is
      select hcsu.* 
      from   hz_cust_site_uses_all hcsu,
             hr_organization_information hoi      
      where  hcsu.org_id = hoi.organization_id
      and    hoi.org_information_context = 'Operating Unit Information' 
      and    hoi.org_information3 = to_char(p_set_of_books_id); 	

begin
   l_pathname := '/tmp';
   l_filename := 'CAPAR_CUSTOMER_SITE_USE.dat';
   l_utl_file := utl_file.fopen(l_pathname, l_filename, 'w');
   
   l_processed_count := 0;
   l_rejected_count  := 0;
   
   l_ngo_sob := '&1';
   
   begin
     select set_of_books_id
     into   l_set_of_books_id
     from   gl_sets_of_books
     where  upper(short_name) = upper(l_ngo_sob);
   exception
     when others then
       dbms_output.put_line(l_ngo_sob||': set of books short name not found');
       --raise;
   end;   

   for cur in cur_site_use(l_set_of_books_id) loop   	
     
     -- output data
     utl_file.put_line( l_utl_file, 
       cur.SITE_USE_ID                     || chr(9) ||
       cur.CUST_ACCT_SITE_ID               || chr(9) ||
       cur.LAST_UPDATE_DATE                || chr(9) ||
       cur.LAST_UPDATED_BY                 || chr(9) ||
       cur.CREATION_DATE                   || chr(9) ||
       cur.CREATED_BY                      || chr(9) ||
       cur.SITE_USE_CODE                   || chr(9) ||
       cur.PRIMARY_FLAG                    || chr(9) ||
       cur.STATUS                          || chr(9) ||
       cur.LOCATION                        || chr(9) ||
       cur.LAST_UPDATE_LOGIN               || chr(9) ||
       cur.CONTACT_ID                      || chr(9) ||
       cur.BILL_TO_SITE_USE_ID             || chr(9) ||
       cur.ORIG_SYSTEM_REFERENCE           || chr(9) ||
       cur.SIC_CODE                        || chr(9) ||
       cur.PAYMENT_TERM_ID                 || chr(9) ||
       cur.GSA_INDICATOR                   || chr(9) ||
       cur.SHIP_PARTIAL                    || chr(9) ||
       cur.SHIP_VIA                        || chr(9) ||
       cur.FOB_POINT                       || chr(9) ||
       cur.ORDER_TYPE_ID                   || chr(9) ||
       cur.PRICE_LIST_ID                   || chr(9) ||
       cur.FREIGHT_TERM                    || chr(9) ||
       cur.WAREHOUSE_ID                    || chr(9) ||
       cur.TERRITORY_ID                    || chr(9) ||
       cur.ATTRIBUTE_CATEGORY              || chr(9) ||
       cur.ATTRIBUTE1                      || chr(9) ||
       cur.ATTRIBUTE2                      || chr(9) ||
       cur.ATTRIBUTE3                      || chr(9) ||
       cur.ATTRIBUTE4                      || chr(9) ||
       cur.ATTRIBUTE5                      || chr(9) ||
       cur.ATTRIBUTE6                      || chr(9) ||
       cur.ATTRIBUTE7                      || chr(9) ||
       cur.ATTRIBUTE8                      || chr(9) ||
       cur.ATTRIBUTE9                      || chr(9) ||
       cur.ATTRIBUTE10                     || chr(9) ||
       cur.REQUEST_ID                      || chr(9) ||
       cur.PROGRAM_APPLICATION_ID          || chr(9) ||
       cur.PROGRAM_ID                      || chr(9) ||
       cur.PROGRAM_UPDATE_DATE             || chr(9) ||
       cur.TAX_REFERENCE                   || chr(9) ||
       cur.SORT_PRIORITY                   || chr(9) ||
       cur.TAX_CODE                        || chr(9) ||
       cur.ATTRIBUTE11                     || chr(9) ||
       cur.ATTRIBUTE12                     || chr(9) ||
       cur.ATTRIBUTE13                     || chr(9) ||
       cur.ATTRIBUTE14                     || chr(9) ||
       cur.ATTRIBUTE15                     || chr(9) ||
       cur.ATTRIBUTE16                     || chr(9) ||
       cur.ATTRIBUTE17                     || chr(9) ||
       cur.ATTRIBUTE18                     || chr(9) ||
       cur.ATTRIBUTE19                     || chr(9) ||
       cur.ATTRIBUTE20                     || chr(9) ||
       cur.ATTRIBUTE21                     || chr(9) ||
       cur.ATTRIBUTE22                     || chr(9) ||
       cur.ATTRIBUTE23                     || chr(9) ||
       cur.ATTRIBUTE24                     || chr(9) ||
       cur.ATTRIBUTE25                     || chr(9) ||
       cur.LAST_ACCRUE_CHARGE_DATE         || chr(9) ||
       cur.SECOND_LAST_ACCRUE_CHARGE_DATE  || chr(9) ||
       cur.LAST_UNACCRUE_CHARGE_DATE       || chr(9) ||
       cur.SECOND_LAST_UNACCRUE_CHRG_DATE  || chr(9) ||
       cur.DEMAND_CLASS_CODE               || chr(9) ||
       cur.ORG_ID                          || chr(9) ||
       cur.TAX_HEADER_LEVEL_FLAG           || chr(9) ||
       cur.TAX_ROUNDING_RULE               || chr(9) ||
       cur.WH_UPDATE_DATE                  || chr(9) ||
       cur.GLOBAL_ATTRIBUTE1               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE2               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE3               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE4               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE5               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE6               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE7               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE8               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE9               || chr(9) ||
       cur.GLOBAL_ATTRIBUTE10              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE11              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE12              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE13              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE14              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE15              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE16              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE17              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE18              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE19              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE20              || chr(9) ||
       cur.GLOBAL_ATTRIBUTE_CATEGORY       || chr(9) ||
       cur.PRIMARY_SALESREP_ID             || chr(9) ||
       cur.FINCHRG_RECEIVABLES_TRX_ID      || chr(9) ||
       cur.DATES_NEGATIVE_TOLERANCE        || chr(9) ||
       cur.DATES_POSITIVE_TOLERANCE        || chr(9) ||
       cur.DATE_TYPE_PREFERENCE            || chr(9) ||
       cur.OVER_SHIPMENT_TOLERANCE         || chr(9) ||
       cur.UNDER_SHIPMENT_TOLERANCE        || chr(9) ||
       cur.ITEM_CROSS_REF_PREF             || chr(9) ||
       cur.OVER_RETURN_TOLERANCE           || chr(9) ||
       cur.UNDER_RETURN_TOLERANCE          || chr(9) ||
       cur.SHIP_SETS_INCLUDE_LINES_FLAG    || chr(9) ||
       cur.ARRIVALSETS_INCLUDE_LINES_FLAG  || chr(9) ||
       cur.SCHED_DATE_PUSH_FLAG            || chr(9) ||
       cur.INVOICE_QUANTITY_RULE           || chr(9) ||
       cur.PRICING_EVENT                   || chr(9) ||
       cur.GL_ID_REC                       || chr(9) ||
       cur.GL_ID_REV                       || chr(9) ||
       cur.GL_ID_TAX                       || chr(9) ||
       cur.GL_ID_FREIGHT                   || chr(9) ||
       cur.GL_ID_CLEARING                  || chr(9) ||
       cur.GL_ID_UNBILLED                  || chr(9) ||
       cur.GL_ID_UNEARNED                  || chr(9) ||
       cur.GL_ID_UNPAID_REC                || chr(9) ||
       cur.GL_ID_REMITTANCE                || chr(9) ||
       cur.GL_ID_FACTOR                    || chr(9) ||
       cur.TAX_CLASSIFICATION              || chr(9) ||
       cur.OBJECT_VERSION_NUMBER           || chr(9) ||
       cur.CREATED_BY_MODULE               || chr(9) ||
       cur.APPLICATION_ID
	 );
     
	 l_processed_count := l_processed_count + 1;
   end loop;

   if l_processed_count = 0 then   
     l_rejected_count := l_rejected_count + 1;
     l_err_msg := l_ngo_sob || ': Customer Site Use not found';
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPAREXT_CUSTOMER_SITE_USE', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;

   utl_file.fclose(l_utl_file);
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/


--exit
